<?php

defined('_JEXEC') or die();
define('DIR_LOGS', JPATH_SITE . '/components/com_jshopping/payments/pm_enot/');

require_once(JPATH_SITE . '/components/com_jshopping/addons/addon_core.php');
require_once(JPATH_SITE . '/components/com_jshopping/payments/pm_enot/enotMerchantAPI.php');

class AddonPMEnot extends AddonCore
{

    protected $addon_alias = 'pmenot';

    private static $instance;

    public function __construct()
    {
        // Прячем конструктор
    }

    private function __clone()
    {
        // Отключаем клонирование
    }

    private function __wakeup()
    {
        // Отключаем десериализацию
    }

    public static function getInstance(): AddonPMEnot
    {
        if (!self::$instance) self::$instance = new self();
        self::$instance->params = self::$instance->getAddonParams();
        return self::$instance;
    }

    public function getAddonParams()
    {
        if (!$this->addon_params) {
            $addon_params = parent::getAddonParams();
            $registry = new JRegistry();
            $registry->loadArray($addon_params);
            $this->addon_params = $registry;
        }
        return $this->addon_params;
    }


    // Метод получения списка валют
    public function getEnotCurrencies()
    {
        $enot = new EnotMerchantAPI(
            $this->params->get('password_1')
        );

        $json_file = JPATH_SITE . '/components/com_jshopping/payments/pm_enot/currencies.json';
        // Если файла нет или он пустой или последний раз он редактировался боле суток назад
        if (!file_exists($json_file) || (filesize($json_file) < 10) || (time() - filemtime($json_file) > 1 * 60 * 60 * 24)) {
            $request = $enot->buildQuery('shops/' . $this->params->get('merchant_id') . '/payment-tariffs', array());
            $json = json_decode($request, true);

            // Если нет ошибок
            if ($json['status'] == 200) {
                // Записываем свежие данные во временный файл с валютами
                file_put_contents($json_file, $request);
            }
        }

        $json_content = file_get_contents($json_file);

        $json = json_decode($json_content, true);

        $groups = array('Способы оплаты');

        $currencies = array();

        if (is_array($json['data']['tariffs']) && count($json['data']['tariffs'])) {
            $tr = array();
            foreach ($groups as $group) {
                $temp_group = new stdclass();
                $temp_group->title = $group;
                $temp_group->currencies = array();

                if (isset($json['data']['tariffs'])) {
                    foreach ($json['data']['tariffs'] as $tarif) {
                        if ($tarif['status'] != 'enabled') continue;

                        if (in_array($tarif['service'], $tr)) continue;

                        $tr[] = $tarif['service'];

                        $temp_currency = new stdclass();
                        $temp_currency->title = $tarif['service_label'];
                        $temp_currency->code = $tarif['service'];
                        $temp_currency->min_sum = $tarif['min_sum'];
                        $temp_currency->max_sum = $tarif['max_sum'];

                        $temp_group->currencies[] = $temp_currency;
                    }
                }
                $currencies[] = $temp_group;
            }
        }
        return $currencies;
    }

    // Метод получения контента с помощью CURL
    private function curlGetContents($url)
    {
        // Инициализируем сеанс cURL
        $ch = curl_init();
        // Устанавливаем опцию не показывать заголовки
        curl_setopt($ch, CURLOPT_HEADER, false);
        // Устанавливаем опцию возврата результата в виде строки
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        //
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        //
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        // Устанавливаем URL
        curl_setopt($ch, CURLOPT_URL, $url);
        // Получаем ответ
        $content = curl_exec($ch);
        // Закрываем соединение
        curl_close($ch);
        // Возвращаем результат
        return $content;
    }
}
