<?php
defined('JPATH_PLATFORM') or die;

JFormHelper::loadFieldClass('groupedlist');

class JFormFieldEnotCurrency extends JFormFieldGroupedList
{
    protected $type = 'EnotCurrency';

    protected $addon;

    public function __construct()
    {
        $this->addon = AddonPMEnot::getInstance();
    }

    protected function getGroups()
    {
        $groups = array();

        $option = new stdclass();
        $option->value = '-1';
        $option->text = JText::_('JOPTION_DO_NOT_USE');
        $option->disable = '';
        $option->class = '';
        $option->onclick = '';

        $groups[0][] = $option;

        $currency_groups = $this->addon->getEnotCurrencies();

        if (is_array($currency_groups) && count($currency_groups)) {
            foreach ($currency_groups as $currency_group) {

                $groups[$currency_group->title] = array();
                if (is_array($currency_group->currencies) && count($currency_group->currencies)) {
                    foreach ($currency_group->currencies as $currency) {
                        $option = new stdclass();
                        $option->value = $currency->code;
                        $option->text = $currency->title;
                        $option->disable = '';
                        $option->class = '';
                        $option->onclick = '';

                        $groups[$currency_group->title][] = $option;
                    }
                }
            }
        }
        return $groups;
    }
}