<?php
defined('JPATH_PLATFORM') or die;

JFormHelper::loadFieldClass('list');

class JFormFieldEnotCurrencyGroup extends JFormFieldList
{

    protected $type = 'EnotCurrencyGroup';

    protected $addon;

    public function __construct()
    {
        $this->addon = AddonPMEnot::getInstance();
    }

    public function setup(SimpleXMLElement $element, $value, $group = null)
    {
        $return = parent::setup($element, $value, $group);
        if ($return) {
            $hideNone = (string)$this->element['hide_none'];

            $this->hideNone = ($hideNone == 'true' || $hideNone == 'hideNone' || $hideNone == '1');

            $hideDefault = (string)$this->element['hide_default'];

            $this->hideDefault = ($hideDefault == 'true' || $hideDefault == 'hideDefault' || $hideDefault == '1');
        }
        return $return;
    }

    protected function getOptions()
    {
        $options = array();

        if (!$this->hideNone) {
            $options[] = JHtml::_('select.option', '-1', JText::alt('JOPTION_DO_NOT_USE', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
        }
        if (!$this->hideDefault) {
            $options[] = JHtml::_('select.option', '', JText::alt('JOPTION_USE_DEFAULT', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
        }

        $enot_currencies = $this->addon->getEnotCurrencies();
        if (is_array($enot_currencies)) {
            foreach ($enot_currencies as $enot_currency) {
                $options[] = JHtml::_('select.option', $enot_currency->title, $enot_currency->title);
            }
        }
        $options = array_merge(parent::getOptions(), $options);
        return $options;
    }
}
