<?php

defined('_JEXEC') or die();

use Joomla\Component\Jshopping\Site\Lib\JSFactory;

require_once(JPATH_SITE . '/components/com_jshopping/addons/pmenot/pmenot.php');

class pm_enot extends PaymentRoot
{
    private AddonPMEnot $addon;

    public function __construct()
    {
        JSFactory::loadExtLanguageFile('pm_enot');
        $this->addon = AddonPMEnot::getInstance();
        $this->pmconfigs = null;
    }

    function getSavePaymentParams()
    {
        return true;
    }

    // тут показано при выборе
    public function showPaymentForm($params, $pmconfigs)
    {
        // Конвертируем настройки способа оплаты в формат JRegistry
        $cart = \JSFactory::getModel('Cart', 'Site');
        $cart->load("cart");
        $summa = $cart->getSum(0, 1);

        $this->setPMConfigs($pmconfigs);
        // Получаем доступные валюты
        $enot_currencies = $this->addon->getEnotCurrencies();
        $all_dostup = array(); //Все доступные
        $all_ = array(); //Вообще все
        $all_m_ = array(); //Вообще все

        //Исключаем мин макс
        foreach ($enot_currencies as $k => $enot_currencie) {
            foreach ($enot_currencie->currencies as $kk => $currencie) {
                $all_[$currencie->code] = $currencie->title;
                $all_m_[$currencie->code] = array($currencie->min_sum, $currencie->max_sum);

                if ($summa >= $currencie->min_sum && $summa <= $currencie->max_sum) {
                    $all_dostup[$currencie->code] = $currencie->title;
                } else {
                    unset($enot_currencies[$k]->currencies[$kk]);
                }
            }
        }

        echo $this->getRenderer('paymentform.' . $this->pmconfigs->get('payment_form_layout', 'default'))->render(array('payment_class' => $this->pm_method->payment_class,
            'params' => $params,
            'pmconfigs' => $this->pmconfigs,
            'enot_currencies' => $enot_currencies,
            'all_dostup' => $all_dostup,
            'all_' => $all_,
            'all_m_' => $all_m_
        ));
    }

    public function showAdminFormParams($pmconfigs)
    {
        // Конвертируем настройки способа оплаты в формат JRegistry
        $this->setPMConfigs($pmconfigs);
        $enot_currencies = $this->addon->getEnotCurrencies();
        $enot_currency_groups = array();

        $all_groups = new stdclass();
        $all_groups->text = JText::_('PLG_JSHOPPINGADMIN_ADMINPMENOT_ALL_ENOT_CURRENCY_GROUPS');
        $all_groups->value = '';
        $enot_currency_groups[] = $all_groups;

        foreach ($enot_currencies as $group) {
            $temp_group = new stdclass();
            $temp_group->text = $group->title;
            $temp_group->value = $group->code;
            $enot_currency_groups[] = $temp_group;
        }

        $temp = array(
            'title' => '',
            'currencies' => array
            (
                array
                (
                    'title' => JText::_('PLG_JSHOPPINGADMIN_ADMINPMENOT_SELECT_ENOT_CURRENCY'),
                    'code' => '0'
                )
            )

        );

        array_unshift($enot_currencies, $temp);

        $lang = JFactory::getLanguage();

        $lang->load('plg_jshoppingadmin_adminpmenot', JPATH_ADMINISTRATOR, null, false, true);

        JForm::addFormPath(__DIR__ . '/forms');

        $form = JForm::getInstance(
            'adminformparams',
            'adminformparams',
            array('control' => 'pm_params', 'load_data' => true),
            false,
            false
        );

        $form->bind($pmconfigs);

        echo $this->getRenderer('adminformparams')->render(array('form' => $form));
    }

    public function checkTransaction($pmconfigs, $order, $act)
    {
        $error_logs = __DIR__ . '/error.log';
        $hook_logs = __DIR__ . '/hook.log';
        $request_body = file_get_contents('php://input');

        ob_start();
        print_r($request_body);
        $var = ob_get_contents();
        ob_end_clean();

        file_put_contents($hook_logs, date('Y-m-d H:i:s') . " - {$var}\r\n", FILE_APPEND);

        if ($act == 'notify') {

            if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
                file_put_contents($error_logs, date('Y-m-d H:i:s') . ' - callback # enot: Invalid method.' . "\r\n", FILE_APPEND);
                return array(0, _JSHOP_PM_ENOT_MESSAGE_INVALID_TRANSACTION_SIGNATURE);
            }

            $signature_header = $_SERVER['HTTP_X_API_SHA256_SIGNATURE'] ?? '';
            if (!$signature_header) {
                file_put_contents($error_logs, date('Y-m-d H:i:s') . ' - callback # enot: not signature.' . "\r\n", FILE_APPEND);
                return array(0, _JSHOP_PM_ENOT_MESSAGE_INVALID_TRANSACTION_SIGNATURE);
            }

            $sign = $request_body = file_get_contents('php://input');

            $sign = json_decode($sign, true);
            ksort($sign);
            $sign = json_encode($sign);
            $secret_key = $this->addon->params->get('password_2');
            $calculated_signature = hash_hmac('sha256', $sign, $secret_key);

            // Compare the calculated signature with the signature in the header
            if (!hash_equals($signature_header, $calculated_signature)) {
                file_put_contents($error_logs, date('Y-m-d H:i:s') . ' - callback # enot:Invalid signature.' . "\r\n", FILE_APPEND);
                return array(0, _JSHOP_PM_ENOT_MESSAGE_INVALID_TRANSACTION_SIGNATURE2);
            }

            $request_body = json_decode($request_body, true);
            $order_id = $request_body['order_id'] ?? 0;
            if (!$order_id) {
                file_put_contents($error_logs, date('Y-m-d H:i:s') . ' - callback # enot: not order_id.' . "\r\n", FILE_APPEND);
                return array(0, _JSHOP_PM_ENOT_MESSAGE_INVALID_TRANSACTION_SIGNATURE3);
            }

            $status = $request_body['status'] ?? 'unknown';
            if ($status == 'success') {
                // Возвращаем код проверки транзакции "1", сообщающий о том что заказ оплачен
                $result = array(1, $order->order_id);
            } else {
                // Возвращаем код проверки транзакции "0", сообщающий об ошибке и сообщение о некорректной подписи платежа
                $result = array(0, _JSHOP_PM_ENOT_MESSAGE_INVALID_TRANSACTION_SIGNATURE4);
                file_put_contents($error_logs, date('Y-m-d H:i:s') . ' - callback # последний этам не прошли проверку статуса .' . "\r\n", FILE_APPEND);
            }
            return $result;
        }
    }

    public function showEndForm($pmconfigs, $order)
    {
        $pm_method = $this->getPmMethod();
        // Конвертируем настройки способа оплаты в формат JRegistry
        $this->setPMConfigs($pmconfigs);
        // Если в параметрах задано принудительное завершение заказов
        if ($this->addon->params->get('forced_finishing_orders', 0)) {
            // Устанавливаем завершение заказа
            $order->order_created = 1;
            // Сохраняем заказ
            $order->store();
        }
        // ID магазина в нашей системе
        $merchant_id = $this->addon->params->get('merchant_id');
        $password_1 = $this->addon->params->get('password_1');

        $order_sum = number_format($order->order_total, 2, '.', '');
        $order_id = $order->order_id;
        $check_sum = md5($merchant_id . ':' . $order_sum . ':' . $password_1 . ':' . $order_id);
        // Валюта платежа (RUB, USD, EUR, UAH) (По умолчанию RUB)
        $currency_code = mb_strtoupper($order->currency_code_iso);
        $payment_params_data = $order->getPaymentParamsData();
        $enot_currency = $payment_params_data['enot_currency'];

        $data = array(
            'order_id' => (string)$order_id,
            'amount' => $order_sum,
            'currency' => $currency_code,
            'shop_id' => $merchant_id,
            'comment' => (string)$order_id
        );

        $uri = \JURI::getInstance();

        $liveurlhost = \JURI::root();

        if (!empty($enot_currency)) $data['include_service'] = array($enot_currency);
        $data['hook_url'] = $liveurlhost . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=' . $pm_method->payment_class . '&no_lang=1';

        $data['fail_url'] = $liveurlhost . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=' . $pm_method->payment_class;

        $data['success_url'] = $liveurlhost . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=' . $pm_method->payment_class . '&no_lang=1';

        // Если в параметрах задано принудительное завершение заказов
        if ($this->addon->params->get('forced_finishing_orders')) {
            // Устанавливаем завершение заказа
            $order->order_created = 1;
            // Сохраняем заказ
            $order->store();
        }

        $enot = new EnotMerchantAPI(
            $this->addon->params->get('password_1')
        );

        $request = $enot->buildQuery('invoice/create', $data, 'post');

        if (!$request) die('enot: не проходит оплата. Проверьте настройки кассы');

        $request = json_decode($request, true);

        ?>
        <!DOCTYPE html>
        <html>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
        </head>
        <body>

        Переход на оплату
        <br/>
        <script type="text/javascript">

            location.href = '<?=$request['data']['url']?>';

        </script>
        </body>
        </html>
        <?php
        // Прерываем работу
        die();
    }

    public function getUrlParams($pmconfigs)
    {
        // Конвертируем настройки способа оплаты в формат JRegistry
        $this->setPMConfigs($pmconfigs);
        // Получаем объект приложения
        $app = JFactory::getApplication();

        $request_body = file_get_contents('php://input');
        $request_body = json_decode($request_body, true);
        $order_id = $request_body['order_id'] ?? 0;

        $params = array();
        $params['order_id'] = $order_id;
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = ($app->input->getVar('act', '') == 'notify');
        return $params;
    }

    private function setPMConfigs($pmconfigs)
    {
        $registry = new JRegistry();
        $registry->loadArray($pmconfigs);
        $this->pmconfigs = $registry;
    }

    protected function getLayoutPaths()
    {
        $template = JFactory::getApplication()->getTemplate();
        return array
        (
            JPATH_SITE . '/templates/' . $template . '/html/layouts/components/com_jshopping/payments/pm_enot',
            __DIR__ . '/layouts',
        );
    }

    protected function getRenderer($layoutId = 'default')
    {
        $renderer = new JLayoutFile($layoutId);
        $renderer->setIncludePaths($this->getLayoutPaths());
        return $renderer;
    }
}