<?php

defined('_JEXEC') or die;

require_once(JPATH_SITE . '/components/com_jshopping/addons/pmenot/pmenot.php');

class plgJShoppingAdminAdminPMEnot extends JPlugin
{
    private $addon = null;

    private $title = null;

    protected $autoloadLanguage = true;

    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->title = 'PLG_' . $config['type'] . '_' . $config['name'];
        $this->addon = AddonPMEnot::getInstance();
    }

    public function onBeforeEditAddons(&$view)
    {
        if ($view->row->alias == 'pmenot') {
            $document = JFactory::getDocument();
            unset($document->_styleSheets[JURI::root() . 'administrator/components/com_jshopping/css/style.css']);
        }
    }

    public function onBeforeEditPayments(&$view)
    {
        if ($view->payment->scriptname == 'pm_enot') {
            $document = JFactory::getDocument();
            unset($document->_styleSheets[JURI::root() . 'administrator/components/com_jshopping/css/style.css']);
        }
    }

    public function onBeforeShowOrderListView(&$view)
    {
        $view->_tmp_cols_5 .= '<th></th>';
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select($db->quoteName('payment_id'));
        $query->from($db->quoteName('#__jshopping_payment_method'));
        $query->where($db->quoteName('scriptname') . ' = ' . $db->quote('pm_enot'));
        $db->setQuery($query);

        $payment_method_ids = $db->loadColumn(0);
        if (is_array($view->rows) && count($view->rows)) {
            foreach ($view->rows as $k => $row) {
                if (in_array($row->payment_method_id, $payment_method_ids)) {
                    $notification_url = JURI::root() . 'index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=pm_enot';
                    // ID вашего магазина
                    $merchant = $this->addon->params->get('merchant_id');
                    // Сумма заказа
                    $amount = number_format($row->order_total, 2, '.', '');
                    // Сумма зачисленная вам на баланс (В рублях)
                    $credited = 0;
                    // ID операции в нашей системе
                    $intid = 0;
                    // ID операции в вашей системе
                    $merchant_id = $row->order_id;
                    // ключ, который вы генерировали до оплаты заказа
                    $sign = md5(
                        $this->addon->params->get('merchant_id')
                        . ':'
                        . number_format($row->order_total, 2, '.', '')
                        . ':'
                        . $this->addon->params->get('password_1')
                        . ':'
                        . $row->order_id
                    );
                    // ключ, который сгенерирован, как SIGN, но с секретным ключом №2
                    $sign_2 = md5(
                        $this->addon->params->get('merchant_id')
                        . ':'
                        . number_format($row->order_total, 2, '.', '')
                        . ':'
                        . $this->addon->params->get('password_2')
                        . ':'
                        . $row->order_id
                    );
                    // Валюта платежа (RUB, USD, EUR, UAH) (Зависит от валюты магазина. По умолчанию RUB)
                    $currency = '';
                    // Сумма комиссии при заказе (Зависит от валюты платежа. По умолчанию RUB)
                    $commission = '';

                    $displayData = array();
                    $displayData['k'] = $k;
                    $displayData['notification_url'] = $notification_url;
                    $displayData['merchant'] = $merchant;  // ID вашего магазина
                    $displayData['amount'] = $amount;
                    $displayData['credited'] = $credited;
                    $displayData['intid'] = $intid;
                    $displayData['merchant_id'] = $merchant_id;
                    $displayData['method'] = $method;
                    $displayData['sign'] = $sign;
                    $displayData['sign_2'] = $sign_2;
                    $displayData['currency'] = $currency;
                    $displayData['commission'] = $commission;
                    $view->_tmp_order_list_html_end .= '<td>' . $this->getRenderer('testing')->render($displayData) . '</td>';
                    $row->_tmp_cols_5 .= '<td><button onClick="document.getElementById(\'pm_enot_test_notify_' . $k . '\').submit();" type="button">test payment notify</button></td>';
                } else {
                    $row->_tmp_cols_5 .= '<td></td>';
                }
            }
        }
    }

    protected function getLayoutPaths()
    {
        $template = JFactory::getApplication()->getTemplate();
        return array(
            JPATH_ADMINISTRATOR . '/templates/' . $template . '/html/layouts/plugins/' . $this->_type . '/' . $this->_name,
            __DIR__ . '/layouts',
        );
    }

    protected function getRenderer($layoutId = 'default')
    {
        $renderer = new JLayoutFile($layoutId);
        $renderer->setIncludePaths($this->getLayoutPaths());
        return $renderer;
    }
}